program z(input,output);

const
   try = 500;

%include 'bm.inc'

[external] procedure mxtran_pas(var x,y:matrix);external;
[external] procedure mxtran_for(var x,y:matrix);external;
[external] procedure mxtran_c(var x,y:matrix);external;
[external] procedure mxtran_mar(var x,y:matrix);external;
[external] procedure mxtran_mar_cheat(var x,y:matrix);external;
[external] procedure mxcopy_pas(var x,y:matrix);external;
[external] procedure mxcopy_for(var x,y:matrix);external;
[external] procedure mxcopy_c(var x,y:matrix);external;
[external] procedure mxcopy_mar(var x,y:matrix);external;
[external] procedure mxcopy_mar_cheat(var x,y:matrix);external;
[external] function vecdot_pas(var v1,v2:vector):double;external;
[external] function vecdot_for(var v1,v2:vector):double;external;
[external] function vecdot_c(var v1,v2:vector):double;external;
[external] function vecdot_mar(var v1,v2:vector):double;external;
[external] function vecdot_mar_cheat(var v1,v2:vector):double;external;
                                
var
   cpu1,cpu2,i,j : integer;
   x,y           : matrix;
   v1,v2         : vector;
   r             : double;

begin
   for i:=1 to dim do for j:=1 to dim do begin
      x[i,j]:=(i-1)*dim+j;
      y[i,j]:=0;
   end;
   cpu1:=clock;
   for i:=1 to try do mxtran_pas(x,y);
   cpu2:=clock;
   writeln('Transpose in PASCAL : ',(cpu2-cpu1):1);
   cpu1:=clock;
   for i:=1 to try do mxtran_for(x,y);
   cpu2:=clock;
   writeln('Transpose in FORTRAN : ',(cpu2-cpu1):1);
   cpu1:=clock;
   for i:=1 to try do mxtran_c(x,y);
   cpu2:=clock;
   writeln('Transpose in C : ',(cpu2-cpu1):1);
   cpu1:=clock;
   for i:=1 to try do mxtran_mar(x,y);
   cpu2:=clock;
   writeln('Transpose in MACRO : ',(cpu2-cpu1):1);
   cpu1:=clock;
   for i:=1 to try do mxtran_mar_cheat(x,y);
   cpu2:=clock;
   writeln('Transpose in MACRO (cheating) : ',(cpu2-cpu1):1);
   cpu1:=clock;
   for i:=1 to try do mxcopy_pas(x,y);
   cpu2:=clock;
   writeln('Copy in PASCAL : ',(cpu2-cpu1):1);
   cpu1:=clock;
   for i:=1 to try do mxcopy_for(x,y);
   cpu2:=clock;
   writeln('Copy in FORTRAN : ',(cpu2-cpu1):1);
   cpu1:=clock;
   for i:=1 to try do mxcopy_c(x,y);
   cpu2:=clock;
   writeln('Copy in C : ',(cpu2-cpu1):1);
   cpu1:=clock;
   for i:=1 to try do mxcopy_mar(x,y);
   cpu2:=clock;
   writeln('Copy in MACRO : ',(cpu2-cpu1):1);
   cpu1:=clock;
   for i:=1 to try do mxcopy_mar_cheat(x,y);
   cpu2:=clock;
   writeln('Copy in MACRO (cheating) : ',(cpu2-cpu1):1);
   for i:=1 to dim do begin
      v1[i]:=i;
      v2[i]:=i+1;
   end;
   cpu1:=clock;
   for i:=1 to (try*dim) do r:=vecdot_pas(v1,v2);
   cpu2:=clock;
   writeln('Dot product in PASCAL : ',(cpu2-cpu1):1);
   cpu1:=clock;
   for i:=1 to (try*dim) do r:=vecdot_for(v1,v2);
   cpu2:=clock;
   writeln('Dot product in FORTRAN : ',(cpu2-cpu1):1);
   cpu1:=clock;
   for i:=1 to (try*dim) do r:=vecdot_c(v1,v2);
   cpu2:=clock;
   writeln('Dot product in C : ',(cpu2-cpu1):1);
   cpu1:=clock;
   for i:=1 to (try*dim) do r:=vecdot_mar(v1,v2);
   cpu2:=clock;
   writeln('Dot product in MACRO : ',(cpu2-cpu1):1);
   cpu1:=clock;
   for i:=1 to (try*dim) do r:=vecdot_mar_cheat(v1,v2);
   cpu2:=clock;
   writeln('Dot product in MACRO (cheating) : ',(cpu2-cpu1):1);
end.
